<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelMetaDiaService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function findMetaDia($CDFILIAL, $DTENTRVENDAINI, $DTENTRVENDAFIN, $DIA, $NRORG) {
        $params = array(
         	":CDFILIAL" => $CDFILIAL,
         	":DTENTRVENDAINI" => $DTENTRVENDAINI,
            ":DTENTRVENDAFIN" => $DTENTRVENDAFIN,
         	":DIA" => $DIA,
         	":NRORG" => $NRORG
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_META_DIA_FATURAMENTO, $params);
    }
  
    const GET_META_DIA_FATURAMENTO = "
        SELECT FILOCAVE.CDFILIAL, FILOCAVE.NRORG, FILOCAVE.DTENTRVENDA, FILOCAVE.NMFILIAL, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL,
              (SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND,0)) +  FILOCAVE.VRTXENTREGA) AS VALOR_VENDIDO,
              SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO,
              FILOCAVE.NRPESMESAVENDA AS NRPESMESAVENDA, FILOCAVE.VRTXENTREGA, FILOCAVE.VRMETADIA, FILOCAVE.VRTCKMED, FILOCAVE.VRDESCONTO,
              TO_CHAR(FILOCAVE.DATA, 'D') AS DIA,
              TO_CHAR(FILOCAVE.DATA, 'DD/MM/YYYY') AS DATA,             
              ((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND,0))   +  FILOCAVE.VRTXENTREGA ) - FILOCAVE.VRMETADIA) AS VRMENOSMETA,
              TRUNC((((SUM(TRUNC(I.QTPRODVEND * ( NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL,0)-  NVL(I.VRDESITVEND, 0)), 2) + NVL(I.VRACRITVEND,0)) + FILOCAVE.VRTXENTREGA))/(FILOCAVE.VRMETADIA)*100),2) AS PERCENTUAL,
              TRUNC((((SUM(TRUNC(I.QTPRODVEND * ( NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL,0)  - NVL(I.VRDESITVEND, 0)), 2)+ NVL(I.VRACRITVEND,0)) + FILOCAVE.VRTXENTREGA))/(FILOCAVE.NRPESMESAVENDA)),2)  AS TCKMED,
              TRUNC(((((SUM(TRUNC(I.QTPRODVEND * ( NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL,0) - NVL(I.VRDESITVEND, 0)), 2) + NVL(I.VRACRITVEND,0)) + FILOCAVE.VRTXENTREGA))/(FILOCAVE.NRPESMESAVENDA))/(FILOCAVE.VRTCKMED)*100),2)  AS PERCTCKMED
         FROM ITEMVENDA I
         JOIN (SELECT FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL,
                      FILOCAVE.DTVENDA, FILOCAVE.DTENTRVENDA, FILOCAVE.NMFILIAL, SUM(FILOCAVE.VRREPIQUEVENDA)  OVER (PARTITION BY FILOCAVE.CDFILIAL, FILOCAVE.DTENTRVENDA)  AS VRREPIQUEVENDA, FILOCAVE.DTABERVENDA,
                      FILOCAVE.NRORG, SUM(FILOCAVE.NRPESMESAVENDA) OVER (PARTITION BY FILOCAVE.CDFILIAL,FILOCAVE.DTENTRVENDA) AS NRPESMESAVENDA,
                      NVL(TXENTREGA.VRTXENTREGA, 0) AS VRTXENTREGA, NVL(TXENTREGA.VRDESCONTO, 0) AS VRDESCONTO, NVL(TXENTREGA.VALOR_VENDIDO, 0 ) VALOR_VENDIDO ,TRUNC(FILOCAVE.VRMETADIA, 2) AS VRMETADIA, FILOCAVE.VRTCKMED, FILOCAVE.DATA
                 FROM (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL,
                              V.DTVENDA, V.DTENTRVENDA, FILOCA.NMFILIAL, NVL(V.VRREPIQUEVENDA, 0) AS VRREPIQUEVENDA, V.DTABERVENDA,
                              FILOCA.NRORG, NVL(V.NRPESMESAVENDA, 1) AS NRPESMESAVENDA, FILOCA.VRMETADIA, FILOCA.VRTCKMED, FILOCA.DATA
                         FROM VENDA V
                         JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.VRMETADIA, FILO.VRTCKMED, FILO.DATA
                                 FROM CAIXA C
                                 JOIN (SELECT L.CDLOJA, L.NMLOJA, FIPA.CDFILIAL, FIPA.NMFILIAL, FIPA.NRORG, L.CDPRODTAXASERV, FIPA.VRMETADIA, FIPA.VRTCKMED, FIPA.DATA
                                         FROM LOJA L
                                         JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG, CASE M.VRMETADIA WHEN 0 THEN 1 ELSE M.VRMETADIA END AS VRMETADIA , CASE M.VRTCKMED WHEN 0 THEN 1 ELSE M.VRTCKMED END AS VRTCKMED, M.DATA
                                                 FROM FILIAL F
                                                 JOIN METADIAREAL M
                                                   ON F.CDFILIAL = M.CDFILIAL
                                                  AND F.NRORG = M.NRORG
                                                WHERE INSTR(:CDFILIAL, F.CDFILIAL) > 0 
                                                  AND F.NRORG =:NRORG 
                                                  AND M.DATA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN) FIPA
                                           ON L.CDFILIAL = FIPA.CDFILIAL
                                          AND L.NRORG = FIPA.NRORG) FILO 
                                   ON C.CDFILIAL = FILO.CDFILIAL 
                                  AND C.CDLOJA = FILO.CDLOJA
                                  AND C.NRORG = FILO.NRORG) FILOCA 
                           ON V.CDCAIXA = FILOCA.CDCAIXA
                          AND V.CDLOJA = FILOCA.CDLOJA
                          AND V.CDFILIAL = FILOCA.CDFILIAL
                          AND V.DTENTRVENDA = FILOCA.DATA
                          AND V.NRORG = FILOCA.NRORG
                        WHERE V.IDSITUVENDA = 'O' 
                          AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN
                          ) FILOCAVE
                 LEFT JOIN (SELECT V.CDFILIAL, V.DTENTRVENDA, NVL(SUM(NVL(I.VRACRITVEND,0))- SUM(NVL(V.VRREPIQUEVENDA,0)), 0) AS VRTXENTREGA, SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO,
                  SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND, 0)) AS VALOR_VENDIDO
                         FROM ITEMVENDA I
                         JOIN LOJA L
                           ON I.CDPRODUTO   = L.CDPRODTAXAENTR
                          AND I.CDFILIAL    = L.CDFILIAL
                          AND I.NRORG = L.NRORG 
                         JOIN VENDA V
                           ON I.NRSEQVENDA  = V.NRSEQVENDA
                          AND I.CDFILIAL    = V.CDFILIAL
                          AND I.CDCAIXA     = V.CDCAIXA
                          AND L.CDLOJA      = V.CDLOJA
                          AND L.CDFILIAL      = V.CDFILIAL
                         JOIN PARAVEND P
                           ON I.CDFILIAL    = P.CDFILIAL
                        WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0    
                          AND L.IDTRATTAXAENTR = 'P'              AND SUBSTR(V.IDORIGEMVENDA, 0, 3) = 'DLV'    
                          AND I.NRORG = :NRORG                    AND V.IDSITUVENDA = 'O'
                          AND V.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN
                        GROUP BY V.CDFILIAL, V.DTENTRVENDA
                      ) TXENTREGA                
                  ON FILOCAVE.CDFILIAL = TXENTREGA.CDFILIAL
                  AND FILOCAVE.DTENTRVENDA = TXENTREGA.DTENTRVENDA
            ) FILOCAVE
           ON FILOCAVE.CDFILIAL = I.CDFILIAL
          AND FILOCAVE.NRORG = I.NRORG
          AND FILOCAVE.NRSEQVENDA = I.NRSEQVENDA
          AND FILOCAVE.CDCAIXA = I.CDCAIXA
      WHERE FILOCAVE.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN
        AND INSTR(:DIA, TO_CHAR(FILOCAVE.DATA, 'D')) > 0
      GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NRORG, FILOCAVE.DTENTRVENDA, FILOCAVE.NMFILIAL, FILOCAVE.NRPESMESAVENDA, FILOCAVE.VRTXENTREGA, FILOCAVE.VRDESCONTO,FILOCAVE.VALOR_VENDIDO, FILOCAVE.VRMETADIA, FILOCAVE.VRTCKMED, FILOCAVE.DATA
      ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.DTENTRVENDA
    ";
}